LeetCode 375 - Wiggle Subsequence


http://bookshadow.com/weblog/2016/07/21/leetcode-wiggle-subsequence/
A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.
For example, [1,7,4,9,2,5] is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast, [1,4,7,2,5] and [1,7,4,5,5] are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.
Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.
Examples:
Input: [1,7,4,9,2,5]
Output: 6
The entire sequence is a wiggle sequence.

Input: [1,17,5,10,13,15,10,5,16,8]
Output: 7
There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8].

Input: [1,2,3,4,5,6,7,8,9]
Output: 2
Follow up:
Can you do it in O(n) time?
X. Approach #2 Dynamic Programming [Accepted]
https://leetcode.com/problems/wiggle-subsequence/discuss/84843/Easy-understanding-DP-solution-with-O(n)-Java-version
For every position in the array, there are only three possible statuses for it.
  • up position, it means nums[i] > nums[i-1]
  • down position, it means nums[i] < nums[i-1]
  • equals to position, nums[i] == nums[i-1]
So we can use two arrays up[] and down[] to record the max wiggle sequence length so far at index i.
If nums[i] > nums[i-1], that means it wiggles up. the element before it must be a down position. so up[i] = down[i-1] + 1; down[i] keeps the same with before.
If nums[i] < nums[i-1], that means it wiggles down. the element before it must be a up position. so down[i] = up[i-1] + 1; up[i] keeps the same with before.
If nums[i] == nums[i-1], that means it will not change anything becasue it didn't wiggle at all. so both down[i] and up[i] keep the same.
In fact, we can reduce the space complexity to O(1), but current way is more easy to understanding.
public class Solution {
    public int wiggleMaxLength(int[] nums) {
        
        if( nums.length == 0 ) return 0;
        
        int[] up = new int[nums.length];
        int[] down = new int[nums.length];
        
        up[0] = 1;
        down[0] = 1;
        
        for(int i = 1 ; i < nums.length; i++){
            if( nums[i] > nums[i-1] ){
                up[i] = down[i-1]+1;
                down[i] = down[i-1];
            }else if( nums[i] < nums[i-1]){
                down[i] = up[i-1]+1;
                up[i] = up[i-1];
            }else{
                down[i] = down[i-1];
                up[i] = up[i-1];
            }
        }
        
        return Math.max(down[nums.length-1],up[nums.length-1]);
    }

Any element in the array could correspond to only one of the three possible states:
  1. up position, it means nums[i] > nums[i-1]
  2. down position, it means nums[i] < nums[i-1]
  3. equals to position, nums[i] == nums[i-1]
So we can use two arrays up and down to record the max wiggle subsequence length so far at index i. If nums[i] > nums[i-1], that means it wiggles up. The element before it must be a down position. So up[i] = down[i-1] + 1down[i] remains the same as down[i-1]. If nums[i] < nums[i-1], that means it wiggles down. The element before it must be a up position. So down[i] = up[i-1] + 1up[i] remains the same as up[i-1]. If nums[i] == nums[i-1], that means it will not change anything becaue it didn't wiggle at all. So both down[i] and up[i] remain the same as down[i-1] and up[i-1].
At the end, we can find the larger out of up[length-1] and down[length-1] to find the max. wiggle subsequence length, where length refers to the number of elements in the given array.
  • Time complexity : O(n). Only one pass over the array length.
  • Space complexity : O(n). Two arrays of the same length are used for dp.
    public int wiggleMaxLength(int[] nums) {
        if (nums.length < 2)
            return nums.length;
        int[] up = new int[nums.length];
        int[] down = new int[nums.length];
        up[0] = down[0] = 1;
        for (int i = 1; i < nums.length; i++) {
            if (nums[i] > nums[i - 1]) {
                up[i] = down[i - 1] + 1;
                down[i] = down[i - 1];
            } else if (nums[i] < nums[i - 1]) {
                down[i] = up[i - 1] + 1;
                up[i] = up[i - 1];
            } else {
                down[i] = down[i - 1];
                up[i] = up[i - 1];
            }
        }
        return Math.max(down[nums.length - 1], up[nums.length - 1]);
    }
利用两个辅助数组inc, dec分别保存当前状态为递增/递减的子序列的最大长度。
def wiggleMaxLength(self, nums): """ :type nums: List[int] :rtype: int """ size = len(nums) inc, dec = [1] * size, [1] * size for x in range(size): for y in range(x): if nums[x] > nums[y]: inc[x] = max(inc[x], dec[y] + 1) elif nums[x] < nums[y]: dec[x] = max(dec[x], inc[y] + 1) return max(inc + dec) if size else 0

Approach #3 Space-Optimized Dynamic Programming [Accepted]

This approach relies on the same concept as Approach 2. But we can observe that in the DP approach, for updating elements up[i] and down[i], we need only the elements up[i-1] and down[i-1]. Thus, we can save space by not using the whole array, but only the last elements.
    public int wiggleMaxLength(int[] nums) {
        if (nums.length < 2)
            return nums.length;
        int down = 1, up = 1;
        for (int i = 1; i < nums.length; i++) {
            if (nums[i] > nums[i - 1])
                up = down + 1;
            else if (nums[i] < nums[i - 1])
                down = up + 1;
        }
        return Math.max(down, up);
    }
X. Tuning Point, tow pointers
方法二 虽然dp简单,但其复杂度O(n^2)并不是本题最佳解法。
摇摆序列要求升高,降低,升高。。。
或者降低,升高,降低。。。
那么我们只要找出数组中的“拐点” 即可 举个例子:
4 5 6  3 2 1这几个数中,4为起点,那么5和6中,我们肯定选6啊~因为之后的数要求小于5,小于5的必定也小于6 比如改为4 5 6 5,之前要是选5就没办法继续往下了。。
总之就是选最小的和选最大的(也就是拐点) 保证不丢最优解。

The problem is converted to finding the turning point. When nums[i] < nums[i+1], we want to keep going to the right until finding the largest one, which is the turning point. Similarly, when nums[i] > nums[i+1], we want to keep going to the right until finding the smallest one, which is the turning point. We always want to use the largest or smallest as the turning point because that guarantees the optimal solution.
public int wiggleMaxLength(int[] nums) {
    if(nums == null || nums.length==0)
        return 0;
    if(nums.length<2){
        return nums.length;
    }    
 
    int count=1;
 
 
    for(int i=1, j=0; i<nums.length; j=i, i++){
        if(nums[j]<nums[i]){
            count++;
            while(i<nums.length-1 && nums[i]<=nums[i+1]){
                i++;
            }
        }else if(nums[j]>nums[i]){
            count++;
            while(i<nums.length-1 && nums[i]>=nums[i+1]){
                i++;
            }
        }
    }
 
    return count;
}

X.  Greedy 解法I O(n) 遍历

We need not necessarily need dp to solve this problem. This problem is equivalent to finding the number of alternating max. and min. peaks in the array. Since, if we choose any other intermediate number to be a part of the current wiggle subsequence, the maximum length of that wiggle subsequence will always be less than or equal to the one obtained by choosing only the consecutive max. and min. elements.
This can be clarified by looking at the following figure:Wiggle Peaks
From the above figure, we can see that if we choose C instead of D as the 2nd point in the wiggle subsequence, we can't include the point E. Thus, we won't obtain the maximum length wiggle subsequence.
Thus, to solve this problem, we maintain a variable \text{prevdiff}, where \text{prevdiff} is used to indicate whether the current subsequence of numbers lies in an increasing or decreasing wiggle. If \text{prevdiff} > 0, it indicates that we have found the increasing wiggle and are looking for a decreasing wiggle now. Thus, we update the length of the found subsequence when \text{diff} (nums[i]-nums[i-1]) becomes negative. Similarly, if \text{prevdiff} < 0, we will update the count when \text{diff} (nums[i]-nums[i-1]) becomes positive.
When the complete array has been traversed, we get the required count, which represents the length of the longest wiggle subsequence.
    public int wiggleMaxLength(int[] nums) {
        if (nums.length < 2)
            return nums.length;
        int prevdiff = nums[1] - nums[0];
        int count = prevdiff != 0 ? 2 : 1;//\\
        for (int i = 2; i < nums.length; i++) {
            int diff = nums[i] - nums[i - 1];
            if ((diff > 0 && prevdiff <= 0) || (diff < 0 && prevdiff >= 0)) {
                count++;
                prevdiff = diff;
            }
        }
        return count;
    }

http://www.cnblogs.com/grandyang/p/5697621.html
题目中有个Follow up说要在O(n)的时间内完成,而Greedy算法正好可以达到这个要求,这里我们不在维护两个dp数组,而是维护两个变量p和q,然后遍历数组,如果当前数字比前一个数字大,则p=q+1,如果比前一个数字小,则q=p+1,最后取p和q中的较大值跟n比较,取较小的那个

    int wiggleMaxLength(vector<int>& nums) {
        int p = 1, q = 1, n = nums.size();
        for (int i = 1; i < n; ++i) {
            if (nums[i] > nums[i - 1]) p = q + 1;
            else if (nums[i] < nums[i - 1]) q = p + 1;
        }
        return min(n, max(p, q));
    }
https://discuss.leetcode.com/topic/51893/two-solutions-one-is-dp-the-other-is-greedy-8-lines/2
    int wiggleMaxLength(vector<int>& nums) {
        int count1 = 1, count2 = 1;
        for(int i = 1; i < nums.size(); ++i) 
            if(nums[i] > nums[i-1]) count1 = count2 + 1;
            else if(nums[i] < nums[i-1]) count2 = count1 + 1;
        return nums.size() == 0 ? 0 : max(count1, count2);
    }
https://segmentfault.com/n/1330000006055505
样例输入曲线图
不难发现,最长摆动子序列的长度为波峰波谷的个数和,即上升和下降曲线的段数和加 1
思路有了,写代码就容易了。
  1. 用 gradient 表示当前线段的梯度,>0 表示上升,=0 表示水平, <0 表示下降;初始为 0;
  2. 用 diff 表示当前数字与前一个数的差;
  3. 若 gradient 与 diff 符号不同,则总线段数 +1
  4. 若 diff 为 0 或者 gradient 与 diff 同号,则线段的趋势不变
    int wiggleMaxLength(vector<int>& nums) {
        int n = nums.size();
        if (n <= 1) return n; 
        int gradient = 0;
        int segment = 0;
        for (int i = 1; i < n; i++) {
            int diff = nums[i] - nums[i-1];
            if (diff == 0 || gradient * diff > 0)
                continue;
            else if (gradient == 0) {
                gradient = diff;
                segment = 1;
            } else if (gradient * diff < 0) {
                segment++;
                gradient = diff;
            }
        }
        return segment+1;        
    }
http://www.cnblogs.com/grandyang/p/5697621.html

    int wiggleMaxLength(vector<int>& nums) {
        int p = 1, q = 1, n = nums.size();
        for (int i = 1; i < n; ++i) {
            if (nums[i] > nums[i - 1]) p = q + 1;
            else if (nums[i] < nums[i - 1]) q = p + 1;
        }
        return min(n, max(p, q));
    }
http://storypku.com/2016/07/leetcode-question-376-wiggle-subsequence/
    int wiggleMaxLength(vector<int>& nums) {
        int n = nums.size();
        if (n == 0) return 0;
        
        int up = 1, down = 1;
        for (int i = 1; i < n; i++) {
            int diff = nums[i] - nums[i-1];
            if (diff > 0) {
                up = down + 1;
            } else if (diff < 0) {
                down = up + 1;
            }
        }
        return std::max(up, down);
    }
http://www.programcreek.com/2014/07/leetcode-wiggle-subsequence-java/
一次遍历,将序列的连续递增部分和递减部分进行合并。
def wiggleMaxLength(self, nums): """ :type nums: List[int] :rtype: int """ size = len(nums) if size < 2: return size delta = nums[1] - nums[0] ans = 1 + (delta != 0) for x in range(2, size): newDelta = nums[x] - nums[x-1] if newDelta != 0 and newDelta * delta <= 0: ans += 1 delta = newDelta return ans

摇摆序列要求升高,降低,升高。。。
或者降低,升高,降低。。。
那么我们只要找出数组中的“拐点” 即可 举个例子:
4 5 6  3 2 1这几个数中,4为起点,那么5和6中,我们肯定选6啊~因为之后的数要求小于5,小于5的必定也小于6 比如改为4 5 6 5,之前要是选5就没办法继续往下了。。
总之就是选最小的和选最大的(也就是拐点) 保证不丢最优解。
    public int wiggleMaxLength(int[] nums) {
        if (nums.length == 0) return 0;
int n = nums.length;
int ans = 1;
for (int i = 1, j = 0; i < n; j = i,i++) {
if (nums[j] < nums[i]) {
ans++;
while (i + 1 < n && nums[i] <= nums[i + 1]) i++;
}
else if (nums[j] > nums[i]) {
ans++;
while (i + 1 < n && nums[i] >= nums[i + 1]) i++;
}
}
return ans;
    }
https://www.hrwhisper.me/leetcode-wiggle-subsequence/
方法一,看到这个就想到和LIS差不多,迅速的DP一下,1A,
设dp[i] 为以i结尾的最大摆动序列长度,sign[i]为i这个数比之前的大还是小(大为1,小-1,初始0),更新条件如下:
  • dp[j] + 1 > dp[i] and (sign[j] > 0 and nums[i] < nums[j] or sign[j] < 0 and nums[i] > nums[j] or sign[j] == 0):
X. DP 解法II O(n ^ 2) 动态规划
https://leetcode.com/articles/wiggle-subsequence/
To understand this approach, take two arrays for dp named up and down.
Whenever we pick up any element of the array to be a part of the wiggle subsequence, that element could be a part of a rising wiggle or a falling wiggle depending upon which element we have taken prior to it.
up[i] refers to the length of the longest wiggle subsequence obtained so far considering i^{th} element as the last element of the wiggle subsequence and ending with a rising wiggle.
Similarly, down[i] refers to the length of the longest wiggle subsequence obtained so far considering i^{th} element as the last element of the wiggle subsequence and ending with a falling wiggle.
up[i] will be updated every time we find a rising wiggle ending with the i^{th} element. Now, to find up[i], we need to consider the maximum out of all the previous wiggle subsequences ending with a falling wiggle i.e. down[j], for every j<i and nums[i]>nums[j]. Similarly, down[i] will be updated.
    public int wiggleMaxLength(int[] nums) {
        if (nums.length < 2)
            return nums.length;
        int[] up = new int[nums.length];
        int[] down = new int[nums.length];
        for (int i = 1; i < nums.length; i++) {
            for(int j = 0; j < i; j++) {
                if (nums[i] > nums[j]) {
                    up[i] = Math.max(up[i],down[j] + 1);
                } else if (nums[i] < nums[j]) {
                    down[i] = Math.max(down[i],up[j] + 1);
                }
            }
        }
        return 1 + Math.max(down[nums.length - 1], up[nums.length - 1]);
    }

X. DP O(N)
https://discuss.leetcode.com/topic/52076/easy-understanding-dp-solution-with-o-n-java-version
For every position in the array, there are only three possible statuses for it.
  • up position, it means nums[i] > nums[i-1]
  • down position, it means nums[i] < nums[i-1]
  • equals to position, nums[i] == nums[i-1]
So we can use two arrays up[] and down[] to record the max wiggle sequence length so far at index i.
If nums[i] > nums[i-1], that means it wiggles up. the element before it must be a down position. so up[i] = down[i-1] + 1; down[i] keeps the same with before.
If nums[i] < nums[i-1], that means it wiggles down. the element before it must be a up position. so down[i] = up[i-1] + 1; up[i] keeps the same with before.
If nums[i] == nums[i-1], that means it will not change anything becasue it didn't wiggle at all. so both down[i] and up[i] keep the same.
In fact, we can reduce the space complexity to O(1), but current way is more easy to understanding.
    public int wiggleMaxLength(int[] nums) {
        if (nums.length == 0) return 0;
        int up = 1, down = 1;
        for (int i = 1; i < nums.length; i++) {
            if (nums[i] < nums[i - 1]) down = up + 1;
            else if (nums[i] > nums[i - 1]) up = down + 1;
        }
        return Math.max(up, down);
    }
http://blog.csdn.net/qq508618087/article/details/51991068
可以看到如果以动态规划的方式来解决是比较直观的, 其状态转移方程也比较容易得出: 
if(nums[i]-nums[j])*(nums[j]-nums[j-1] <0) dp[i] = max(dp[i], dp[j]+1);
else dp[i] = max(dp[i], dp[j]);
  1.     int wiggleMaxLength(vector<int>& nums) {  
  2.         if(nums.size() < 2) return nums.size();  
  3.         int len = nums.size();  
  4.         vector<int> dp(len, 0);  
  5.         dp[0] = 1, dp[1]= dp[0] + (nums[1]!=nums[0]);  
  6.         for(int i = 2; i < len; i++)  
  7.         {  
  8.             for(int j = 1; j < i; j++)  
  9.             {  
  10.                 dp[i] = max(dp[i], dp[j] + ((nums[i]-nums[j])*(nums[j]-nums[j-1])<0));  
  11.             }  
  12.         }  
  13.         return dp[len-1];  
  14.     }
https://leetcode.com/articles/wiggle-subsequence/
Approach #1 Brute Force [Time Limit Exceeded]
  • Time complexity : O(n!)\text{calculate}() will be called maximum n! times.
  • Space complexity : O(n). Recursion of depth n is used.
Here, we can find the length of every possible wiggle subsequence and find the maximum length out of them. To implement this, we use a recursive function,\text{calculate}(\text{nums}, \text{index}, \text{isUp}) which takes the array \text{nums}, the \text{index} from which we need to find the length of the longest wiggle subsequence, boolean variable \text{isUp} to tell whether we need to find an increasing wiggle or decreasing wiggle respectively. If the function \text{calculate} is called after an increasing wiggle, we need to find the next decreasing wiggle with the same function. If the function \text{calculate} is called after a decreasing wiggle, we need to find the next increasing wiggle with the same function.

    private int calculate(int[] nums, int index, boolean isUp) {
        int maxcount = 0;
        for (int i = index + 1; i < nums.length; i++) {
            if ((isUp && nums[i] > nums[index]) || (!isUp && nums[i] < nums[index]))
                maxcount = Math.max(maxcount, 1 + calculate(nums, i, !isUp));
        }
        return maxcount;
    }

    public int wiggleMaxLength(int[] nums) {
        if (nums.length < 2)
            return nums.length;
        return 1 + Math.max(calculate(nums, 0, true), calculate(nums, 0, false));
    }

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts